// code by jph

public class AniBomb
extends AniWarpable
{
  static final int[] EXP0_X={0,-1,1, 0,0};
  static final int[] EXP0_Y={1, 0,0,-1,0};
  static final int[] EXP3_X={-2,-1, 0, 1, 2, 2, 2, 2, 2, 1, 0,-1,-2,-2,-2,-2};
  static final int[] EXP3_Y={-2,-2,-2,-2,-2,-1, 0, 1, 2, 2, 2, 2, 2, 1, 0,-1};  
  static final int[] STEP={20,13,9,0,5};
  static final int[] DELAY={15,17,40, 1024 ,14};
  static final int   TYPE0=5; // DELAY when in motion
  static final int[] SENSE={1024,3,5,1024,1024};
  static final int[] SEG_X={6,12,12,4,15};  
  static final int[] INVERSE={3,2,1,0};
    
  int type;
  long explode;  
  long sense;
  int tpy3_num=0;
  int tpy3_ofs;
  
  public AniBomb(int type,int pos_x,int pos_y) {
    this.type=type;
    if (type==3) {
      int ind=myWorldmap.index(pos_x,pos_y);
      this.pos_x=myWorldmap.getPos_x(ind);
      this.pos_y=myWorldmap.getPos_y(ind)-11;
    } else {
      this.pos_x=pos_x;
      this.pos_y=pos_y;
    }
    
    frame=0;
    icon=Animated.BOM_OFS+type;
    clock  =utc+PERMANENT;    // remove from queue
    sense  =utc+SENSE[type];
    explode=utc+DELAY[type];
    tpy3_ofs=myRandom.nextInt(EXP3_X.length);
  }
  
  int uiv2=-1;
  void kick(int uiv2) {    
    this.uiv2=uiv2;
  }
  
  void cont() {
    int ind=myWorldmap.index(pos_x,pos_y);
    if (0<=uiv2&&sense<utc)
      if ((myWorldmap.marks[ind]&ANI_BOMBER)==ANI_BOMBER)
        explode=0;        
  }
  
  void move() {
    if (0<=uiv2) { // move any bomb
      int[] pos=myWorldmap.move(pos_x,pos_y,uiv2,STEP[type]);
      pos_x=pos[0];
      pos_y=pos[1];
      explode*=pos[2];
      if (pos[2]==1)
        frame=(frame+1)%SEG_X[type];
    }
    if (2<type) // animate atomic and ice despite not in motion
      frame=(frame+1)%SEG_X[type];
    if (type==3&&0<myRandom.nextInt(4)) {
      int ind=myWorldmap.index(pos_x,pos_y);
      int loc,loc_x,loc_y;
      do {
        tpy3_num++;
        tpy3_ofs++;
        tpy3_ofs%=EXP3_X.length;
        loc_x=ind+EXP3_X[tpy3_ofs];
        loc_x%=myWorldmap.width;
        loc_y=ind/myWorldmap.width+EXP3_Y[tpy3_ofs];      
        if (0<loc_x&&loc_x<myWorldmap.width&&0<loc_y&&loc_y<myWorldmap.height)
          if ((myWorldmap.field[loc=ind+EXP3_X[tpy3_ofs]+EXP3_Y[tpy3_ofs]*myWorldmap.width]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));
            break;
          }
      } while (tpy3_num<EXP3_X.length);
      if (tpy3_num==EXP3_X.length)
        clock=utc+4;
    }
    if (explode<utc) {
      int c1,c2,loc;
      int dx=0,dy=0;
      int ind=myWorldmap.index(pos_x,pos_y);
      clock=0;
      switch (type) {
        case 0:
          if (0<=uiv2) {
            for (c1=0;c1<EXP0_X.length;c1++)
              if ((myWorldmap.field[loc=ind+EXP0_X[c1]+EXP0_Y[c1]*myWorldmap.width]&Worldmap.MASK_MOVE)!=0&&0<myRandom.nextInt(4))
                myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));
          } else {
            clock=utc+PERMANENT;
            explode=utc+TYPE0;
            uiv2=myRandom.nextInt(4);
            for (c2=0;c2<5;c2++) {
              c1=myRandom.nextInt(4);
              if ((myWorldmap.field[loc=ind+EXP0_X[c1]+EXP0_Y[c1]*myWorldmap.width]&Worldmap.MASK_MOVE)!=0) {
                uiv2=c1;
                break;
              }
            }
          }
          break;
        case 1:                   
          while ((myWorldmap.field[loc=ind+dx+dy*myWorldmap.width]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));
            if (0<uiv2&&uiv2<3) dy++; else dx++;            
            if (2<dx||2<dy)
              break;
          }
          if (0<uiv2&&uiv2<3) dy=-1; else dx=-1;
          while ((myWorldmap.field[loc=ind+dx+dy*myWorldmap.width]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));            
            if (0<uiv2&&uiv2<3) dy--; else dx--;
            if (dx<-2||dy<-2)
              break;
          }
          break;
        case 2:          
          while ((myWorldmap.field[loc=ind+dx++]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));            
          }
          dx=-1;
          while ((myWorldmap.field[loc=ind+dx--]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));            
          }
          dy=1;
          while ((myWorldmap.field[loc=ind+myWorldmap.width*dy++]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));            
          }
          dy=-1;
          while ((myWorldmap.field[loc=ind+myWorldmap.width*dy--]&Worldmap.MASK_MOVE)!=0) {
            myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));            
          }          
          break;
        case 4:
          for (c1=0;c1<EXP0_X.length;c1++)
            if ((myWorldmap.field[loc=ind+EXP0_X[c1]+EXP0_Y[c1]*myWorldmap.width]&Worldmap.MASK_MOVE)!=0)
              myListIterator.add(new AniFire(type,myWorldmap.getPos_x(loc),myWorldmap.getPos_y(loc)));
          break;
      }      
    }
  }
  
}
