// code by jph

public class AniBomber
extends AniWarpable
{
  static final int[] FRAME_BASE={4,12,8,0};  
  static final int[] READY={5,20,12,25,25};
  
  String IP;
  int UD;
  byte[] myByte=new byte[SpaceBomber.DOWNLINK];
  
  int[] types=new int[5]; // weapon repository
  int type=0;             // current weapon type
  int type_prev=0;        // previous weapon type
  long ready=0;           // next time to launch weapon
  long morph=0;           // next time to change characters
  int stock=0;            // relevant for type 0 bomb
  int resur=0;            // next time to resurect  
  int shild=0;            // time to remove shield
  int shild_icon=0;
  int res_x;
  int res_y;
  
  public AniBomber(String IP,int UD) {
    this.IP=IP;
    this.UD=UD;
    icon=Animated.CHR_OFS+myRandom.nextInt(Animated.CHR_NUM);
    mark=ANI_BOMBER;    
    newInLevel();
    System.out.println("SpaceBomber "+IP+":"+UD);
  }
  
  public void newInLevel() {
    types[0]=types[1]=PERMANENT;
    res_x=myWorldmap.randomPos_x(Worldmap.HASH_VOID);
    res_y=myWorldmap.randomPos_y(Worldmap.HASH_VOID);
    pos_x=myWorldmap.randomPos_x(Worldmap.HASH_CORK);
    pos_y=myWorldmap.randomPos_y(Worldmap.HASH_CORK);
    types[2]=types[3]=0;
    types[4]=PERMANENT;
    newType(4);
    resur=utc+20+myRandom.nextInt(50);
    clock=utc+125;
  }
 
  void kill() {
    if (resur<utc&&shild<utc) { // not dead and not protected
      resur=utc+20+40*BombMaster.myHashtable.size();
      myListIterator.add(new AniVoidstar(Animated.ANGEL,myRandom.nextInt(4)*4,4,pos_x,pos_y,12));
      res_x=pos_x;
      res_y=pos_y;
      pos_x=myWorldmap.randomPos_x(Worldmap.HASH_CORK);
      pos_y=myWorldmap.randomPos_y(Worldmap.HASH_CORK);
      types[4]=(int)PERMANENT;
      newType(4);
    }
  }

  void inject(byte[] myByte) {
    for (int c1=0;c1<myByte.length;c1++)
      this.myByte[c1]=myByte[c1];
    clock=utc+50;
  }
  
  void pick(int pick) {
    if (pick<BUM_SHILD-BUM_OFS)
      types[pick]++;
    if (pick==BUM_SHILD-BUM_OFS)
      shild(100);
  }
  
  void shild(int myInt) { // from now on offer protection for a while
    shild=utc+myInt;
    shild_icon=myRandom.nextInt(30);
  }
  
  void move() {
    int c1,ind,lane;
    int framed=frame%4;
    stock=Math.min(100,stock+1);
    for (c1=SpaceBomber.HEADER;c1<myByte.length;c1++) // check for ARROW keys
      if (36<myByte[c1]&&myByte[c1]<41)
        if (resur<utc) {
          frame=FRAME_BASE[myByte[c1]-37];
          int[] pos=myWorldmap.move(pos_x,pos_y,frame/4,9);
          pos_x=pos[0];
          pos_y=pos[1];
          if (pos[2]==1) {
            frame+=(framed+1)%4;
            break;
          }
        } else {
          ind=myWorldmap.index(pos_x,pos_y);
          lane=myWorldmap.lane(ind);
          if (lane==0||lane==3||myWorldmap.corner(ind)) {
            if (myByte[c1]==37) { pos_x-=8; frame++; }
            if (myByte[c1]==39) { pos_x+=8; frame++; }
          }
          if (lane==1||lane==2||myWorldmap.corner(ind)) {
            if (myByte[c1]==38) { pos_y-=8; frame++; }
            if (myByte[c1]==40) { pos_y+=8; frame++; }
          }      
        }
    // <- Bomber has obtained final position
    ind=myWorldmap.index(pos_x,pos_y);
    lane=myWorldmap.lane(ind);
    boolean corner=myWorldmap.corner(ind);
    if (utc<resur) { // when dead
      pos_x=myWorldmap.saf_x(pos_x);
      pos_y=myWorldmap.saf_y(pos_y);
      if (!corner)
        switch (lane) {
          case 0: pos_y=25; break;
          case 1: pos_x=50*myWorldmap.width-25; break;
          case 2: pos_x=25; break;
          case 3: pos_y=50*myWorldmap.height-25; break;
        }
      frame=lane*4+(frame%4);
    }
    if (utc+12==resur) // launch resurection animation
      myListIterator.add(new AniVoidstar(Animated.RESUR,0,12,res_x,res_y-8,12));
    if (utc==resur) { // resurect now
      types[4]=0;  // no iced bombs anymore :-(
      ckdType();   // change to fair bomb type
      shild(35);   // prevent killing for a while      
      pos_x=res_x; // resurect at previous position
      pos_y=res_y; // resurect at previous position
    }
    if (utc<shild) // wear shield (UGLY TECHNIQUE !!!)
      myListIterator.add(new AniVoidstar(Animated.SHILD,shild_icon,1,pos_x,pos_y+13,1));
    for (c1=SpaceBomber.HEADER;c1<myByte.length;c1++) {
      if (48<myByte[c1]&&myByte[c1]<53&&resur<utc) // 1-4 49 50 51 52
        newType(myByte[c1]-49);
      if (32<myByte[c1]&&myByte[c1]<35&&morph<utc) { // PAGE UP PAGE DOWN
        morph=utc+2;
        if (myByte[c1]==33)
          icon--;
        if (myByte[c1]==34)
          icon++;
        if (icon<0)
          icon=Animated.CHR_NUM-1;
        icon%=Animated.CHR_NUM;
      }
      if (myByte[c1]==68) // debug: 'd' for die
        kill();
      if (myByte[c1]==10) { // RETURN        
        myWorldmap.kicks[myWorldmap.kicks_num++]=frame/4;
        myWorldmap.kicks[myWorldmap.kicks_num++]=pos_x;
        myWorldmap.kicks[myWorldmap.kicks_num++]=pos_y;
      }
      if (32==myByte[c1]&&ready<utc&&!corner&&0<stock) { // SPACE
        ready=utc+READY[type];
        stock-=25;
        if (resur<utc) {
          AniBomb myAniBomb=new AniBomb(type,pos_x,pos_y);
          switch (type) {
            case 1:
              myAniBomb.kick(frame/4);
              break;          
            case 2:
              myAniBomb.kick(frame/4);
              break;          
          }
          myListIterator.add(myAniBomb);
          types[type]--;
          if (types[type]==0) type=type_prev;
          if (types[type]==0) type=type_prev=0;
        } else {
          int sum_x=pos_x;
          int sum_y=pos_y;
          switch (lane) {
            case 0: sum_y+=150; break;
            case 1: sum_x-=150; break;
            case 2: sum_x+=150; break;
            case 3: sum_y-=150; break;
          }
          myListIterator.add(new AniBomb(type,sum_x,sum_y));          
        }
      }
    }
  }
  
  void newType(int myInt) {
    if (0<types[myInt]&&type!=myInt) {
      type_prev=type;
      type=myInt;
    }
  }
  
  void ckdType() {
    if (types[type]==0) type=type_prev;
    if (types[type]==0) type=type_prev=0;
  }

}
