// code by jph

import java.util.*;
import javax.swing.*;

abstract class Animated
{
  static final Random myRandom=new Random(System.currentTimeMillis());  
  static final int PERMANENT=1073741824;
  static final int ANI_BOMBER=1;
  static final int ANI_FIRE=2;
  
  static Animation[] myAnimation=new Animation[70];
  static final int CHR_OFS=0;
  static final int CHR_NUM=32;
  static final int BOM_OFS=32;
  static final int BUM_OFS  =40;
  static final int BUM_SHILD=45; // basically type 5 (from 0 1 2 3 4 5)
  static final int FIR_OFS=50;    
  
  static final int SHILD=65;
  static final int RESUR=66;
  static final int FLASH=67;
  static final int ANGEL=68;
  static final int WARPS=69;
	
  public static void resources(JComponent myJComponent) {
    int c1,c2=0;
    for (c1=0;c1<10;c1++) {
      myAnimation[CHR_OFS+ 0+c1]=new Animation(myJComponent,"res/playa_0"+c1+".gif",128,192,4,4);
      myAnimation[CHR_OFS+10+c1]=new Animation(myJComponent,"res/playa_1"+c1+".gif",128,192,4,4);
      myAnimation[CHR_OFS+20+c1]=new Animation(myJComponent,"res/playa_2"+c1+".gif",128,192,4,4);
    }
      myAnimation[CHR_OFS+30]=new Animation(myJComponent,"res/playa_30.gif",160,196,4,4);
      myAnimation[CHR_OFS+31]=new Animation(myJComponent,"res/playa_31.gif",128,204,4,4);
      
    myAnimation[BOM_OFS+0]=new Animation(myJComponent,"res/bombi_00.gif", 282, 47,AniBomb.SEG_X[0],1);
    myAnimation[BOM_OFS+1]=new Animation(myJComponent,"res/bombi_01.gif", 600, 50,AniBomb.SEG_X[1],1);
    myAnimation[BOM_OFS+2]=new Animation(myJComponent,"res/bombi_02.gif", 720, 60,AniBomb.SEG_X[2],1);
    myAnimation[BOM_OFS+3]=new Animation(myJComponent,"res/bombi_03.gif", 140,280,AniBomb.SEG_X[3],4);
    myAnimation[BOM_OFS+4]=new Animation(myJComponent,"res/bombi_04.gif",1200, 80,AniBomb.SEG_X[4],1);
    
    myAnimation[BUM_OFS+0]=new Animation(myJComponent,"res/bumpy_00.gif",140,50,10,1);
    myAnimation[BUM_OFS+1]=new Animation(myJComponent,"res/bumpy_01.gif",240,50,10,1);
    myAnimation[BUM_OFS+2]=new Animation(myJComponent,"res/bumpy_02.gif",270,50,10,1);
    myAnimation[BUM_OFS+3]=new Animation(myJComponent,"res/bumpy_03.gif",150,50,10,1);
    myAnimation[BUM_OFS+4]=new Animation(myJComponent,"res/bumpy_04.gif",308,50,11,1);
    myAnimation[BUM_SHILD]=new Animation(myJComponent,"res/bumpy_05.gif",270,50,10,1);
    
    myAnimation[FIR_OFS+0]=new Animation(myJComponent,"res/fire_00.gif",700, 50,14,1);    
    myAnimation[FIR_OFS+1]=new Animation(myJComponent,"res/fire_01.gif",216,150,6,3);
    myAnimation[FIR_OFS+2]=new Animation(myJComponent,"res/fire_02.gif",500, 50,10,1);    
    myAnimation[FIR_OFS+3]=new Animation(myJComponent,"res/fire_03.gif",600, 50,12,1);  
    myAnimation[FIR_OFS+4]=new Animation(myJComponent,"res/fire_04.gif",150, 30,5,1);
    
    myAnimation[SHILD]=new Animation(myJComponent,"res/uni_shild.gif",430,129,10,3);
    myAnimation[RESUR]=new Animation(myJComponent,"res/uni_resur.gif",128,192,4,3);
    myAnimation[FLASH]=new Animation(myJComponent,"res/uni_flash.gif",300,60,5,1);
    myAnimation[ANGEL]=new Animation(myJComponent,"res/uni_angel.gif",320,256,4,4);
    myAnimation[WARPS]=new Animation(myJComponent,"res/uni_warps.gif",200,200,4,4);
  }
  
  static Worldmap myWorldmap;
  static LinkedList myLinkedList=new LinkedList();
  static ListIterator myListIterator;
  static int utc=0;
  
  abstract void move();
  
  int icon;
  volatile int frame=0; // LATER TEST WITHOUT VOLATILE
  volatile int pos_x;   // LATER TEST WITHOUT VOLATILE
  volatile int pos_y;   // LATER TEST WITHOUT VOLATILE
  volatile int clock;   // LATER TEST WITHOUT VOLATILE
  int mark=0;
  
  static void sims() {
    Animated myAnimated;
    myListIterator=myLinkedList.listIterator();
    while (myListIterator.hasNext()) {
      myAnimated=(Animated)myListIterator.next();
      if (myAnimated.clock<utc)
        myListIterator.remove();
      else {
        myAnimated.move();
        myAnimated.mark();
      }
    }
    myListIterator=myLinkedList.listIterator();
    while (myListIterator.hasNext()) {
      myAnimated=(Animated)myListIterator.next();
      if (myAnimated instanceof AniWarpable)
        myWorldmap.warp((AniWarpable)myAnimated);
      if (myAnimated instanceof AniBomber) {
        myWorldmap.pick((AniBomber)myAnimated);
        myWorldmap.fire((AniBomber)myAnimated);
      }
      if (myAnimated instanceof AniBomb) {
        AniBomb myAniBomb=(AniBomb)myAnimated;
        myAniBomb.cont();
        if (myAniBomb.type==0&&myAniBomb.uiv2<0)
          myWorldmap.kick(myAniBomb);                  
      }
    }
    utc++;
  }
  
  static void castAll(byte[] myByte,int myInt) {
    Animated myAnimated;
    myListIterator=myLinkedList.listIterator();
    while (myListIterator.hasNext())
      myInt+=((Animated)myListIterator.next()).cast(myByte,myInt);
  }
  
  private int cast(byte[] myByte,int myInt) {
    //if (myInt+BombMaster.CHUNK<myByte.length) {
      myByte[myInt+0]=(byte)icon;
      myByte[myInt+1]=(byte)frame;
      myByte[myInt+2]=(byte) pos_x;
      myByte[myInt+3]=(byte)(pos_x/256);
      myByte[myInt+4]=(byte) pos_y;
      myByte[myInt+5]=(byte)(pos_y/256);
      return BombMaster.CHUNK;    
    //} else
    //  return 0;
  }
  
  static void free() {
    Animated myAnimated;
    myListIterator=myLinkedList.listIterator();
    while (myListIterator.hasNext()) {
      myAnimated=(Animated)myListIterator.next();
      if (myAnimated instanceof AniBomber)
        myListIterator.remove();
    }  
  }
  
  void mark() {
    myWorldmap.marks[myWorldmap.index(pos_x,pos_y)]|=mark;
  }
  
}
