// code by jph

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class Worldmap
{
  static final int MASK_SEGM=50;  // width of map square
  static final int MASK_DRAW=31;  // old school
  static final int MASK_MOVE=32;  // old school
  static final int MASK_SIZE=250; // width of texture image
  
	static Image[] myImage=new Image[11];
  static final int TEX_FLOOR=0;
  static final int TEX_WALLS=4;
  
  public static void resources() {
    int c1;
    for (c1=0;c1<4;c1++)
      myImage[TEX_FLOOR+c1]=SpaceBomber.myJComponent.getToolkit().getImage("res/tex_floor_0"+c1+".jpg");
    for (c1=0;c1<7;c1++)
      myImage[TEX_WALLS+c1]=SpaceBomber.myJComponent.getToolkit().getImage("res/tex_walls_0"+c1+".jpg");
  }
  
  // draws worldmap
  public void repaint(Graphics myGraphics) {
    int c1,c2,cnt=0;
    int pix,piy,six,siy;
    for (c2=0;c2<height;c2++)
      for (c1=0;c1<width;c1++) {
        pix=c1*MASK_SEGM;
        piy=c2*MASK_SEGM;
        six=(c1%5)*MASK_SEGM;
        siy=(c2%5)*MASK_SEGM;
        myGraphics.drawImage(myImage[field[cnt++]&MASK_DRAW],
          pix,piy,pix+MASK_SEGM,piy+MASK_SEGM,
          six,siy,six+MASK_SEGM,siy+MASK_SEGM,
          SpaceBomber.myJComponent);
      }
  }

  String myString=""; // ALMOST OBSOLETE
  int playa_min=0;
  int playa_max=5;
  int minutes=3;
  int width=0;
  int height=0;
  int[] field=new int[1024];
  int[] picks=new int[1024];
  int picknum=0;
  int pickups=3;
  int pickavg=90;
  int warprej=3;
  int[] kicks=new int[1024];
  int kicks_num;
  int[] marks=new int[1024];
  int noshild=0;
  String credits="";
  
  Hashtable[] myHashtable=new Hashtable[3];
  static final int HASH_VOID=0; // walking space for winners
  static final int HASH_CORK=1; // walking space for losers
  static final int HASH_WARP=2;
  
  Worldmap(String myString) {
    try {
      int c1,cnt=0;
      for (c1=0;c1<myHashtable.length;c1++)
        myHashtable[c1]=new Hashtable();
      URL myURL=new URL(myString);
      URLConnection myURLConnection=myURL.openConnection();
      myURLConnection.setDoInput(true);
      myURLConnection.setUseCaches(false);
      DataInputStream myDataInputStream=new DataInputStream(myURLConnection.getInputStream());
      while ((myString=myDataInputStream.readLine())!=null) {        
        if (myString.startsWith("players")) {
          String[] mySplit=myString.substring(8).split(" ");
          playa_min=Integer.parseInt(mySplit[0]);
          playa_max=Integer.parseInt(mySplit[2]);
        }
        if (myString.startsWith("minutes")) minutes=Integer.parseInt(new StringTokenizer(myString.substring(8)," ").nextToken());
        if (myString.startsWith("pickups")) pickups=Integer.parseInt(new StringTokenizer(myString.substring(8)," ").nextToken());
        if (myString.startsWith("pickavg")) pickavg=Integer.parseInt(new StringTokenizer(myString.substring(8)," ").nextToken());        
        if (myString.startsWith("warprej")) warprej=Integer.parseInt(new StringTokenizer(myString.substring(8)," ").nextToken());
        if (myString.startsWith("noshild")) noshild=1;
        if (myString.startsWith("credits")) credits=myString.substring(8).trim();
        if (myString.startsWith("#")) {
          myString=myString.trim();
          this.myString+=myString;
          width=myString.length();
          for (c1=0;c1<myString.length();c1++) {
            switch (myString.charAt(c1)) {
              case ' ': myHashtable[HASH_VOID].put(new Integer(myHashtable[HASH_VOID].size()),new Integer(cnt));
                        field[cnt]=TEX_FLOOR+0+MASK_MOVE; break;
              case '.': myHashtable[HASH_VOID].put(new Integer(myHashtable[HASH_VOID].size()),new Integer(cnt));
                        field[cnt]=TEX_FLOOR+1+MASK_MOVE; break;
              case '~': myHashtable[HASH_VOID].put(new Integer(myHashtable[HASH_VOID].size()),new Integer(cnt));
                        field[cnt]=TEX_FLOOR+2+MASK_MOVE; break;
              case '*': myHashtable[HASH_VOID].put(new Integer(myHashtable[HASH_VOID].size()),new Integer(cnt));
                        myHashtable[HASH_WARP].put(new Integer(myHashtable[HASH_WARP].size()),new Integer(cnt));
                        field[cnt]=TEX_FLOOR+0+MASK_MOVE; break;
              case '#': myHashtable[HASH_CORK].put(new Integer(myHashtable[HASH_CORK].size()),new Integer(cnt));
                        field[cnt]=TEX_FLOOR+3; break;
              case 'X': field[cnt]=TEX_WALLS+0; break;
              case 'S': field[cnt]=TEX_WALLS+1; break;
              case 'T': field[cnt]=TEX_WALLS+2; break;
              case 'G': field[cnt]=TEX_WALLS+3; break;
              case 'M': field[cnt]=TEX_WALLS+4; break;
              case 'H': field[cnt]=TEX_WALLS+5; break;
              case 'W': field[cnt]=TEX_WALLS+6; break;              
              default : System.out.println("error in worldmap"); break;
            }
            cnt++;
          }
          height++;
        }
      }
      myDataInputStream.close();
    } catch (Exception myException) {
      System.out.println(myException);
    }
  }  
  
  // adds warps
  void GottesWerk() {
    picknum=0;
    for (int c1=0;c1<width*height;c1++)
      if (myString.charAt(c1)=='*')
        Animated.myLinkedList.add(new AniWarp(c1));    
  }
  
  // depending on number of existing pickups
  // possibly creates a new pickup at a free spot
  void TeufelsBeitrag() {
    int c1,c2;
    for (c1=0;c1<marks.length;c1++)
      marks[c1]=0;
    for (c1=0;c1<kicks.length;c1++)
      kicks[c1]=0;
    kicks_num=0;
    if (picknum<pickups&&myRandom.nextInt(pickavg)==0) {
      do { // determine free location
        random=((Integer)myHashtable[HASH_VOID].get(new Integer(myRandom.nextInt(myHashtable[HASH_VOID].size())))).intValue();
        if (picks[random]!=0)
          random=0;
      } while (random==0);
      switch (myRandom.nextInt(4)+noshild) {
        case 0:
          Animated.myLinkedList.add(new AniPickup(picks[random]=Animated.BUM_SHILD,getPos_x(random),getPos_y(random))); 
          break;
        case 1:
          Animated.myLinkedList.add(new AniPickup(picks[random]=Animated.BUM_OFS+3,getPos_x(random),getPos_y(random))); 
          break;
        default:
          Animated.myLinkedList.add(new AniPickup(picks[random]=Animated.BUM_OFS+2,getPos_x(random),getPos_y(random))); 
          break;
      }
      picknum++;
    }
  }
  
  int getPos_x(int ind) {
    return (ind%width)*MASK_SEGM+MASK_SEGM/2;
  }
  int getPos_y(int ind) {
    return (ind/width)*MASK_SEGM+MASK_SEGM/2;
  }
  
  Random myRandom=new Random(System.currentTimeMillis());
  int random;
  int randomPos_x(int hash) {    
    random=((Integer)myHashtable[hash].get(new Integer(myRandom.nextInt(myHashtable[hash].size())))).intValue();
    return getPos_x(random);
  }  
  int randomPos_y(int hash) {
    return getPos_y(random);
  }
  
  int index(int pos_x,int pos_y) {
    return pos_x/MASK_SEGM+(pos_y/MASK_SEGM)*width;
  }
  
  // make Bomber pickup picks
  void pick(AniBomber myAniBomber) {
    int ind=index(myAniBomber.pos_x,myAniBomber.pos_y);
    if (picks[ind]!=0) {
      myAniBomber.pick(picks[ind]-Animated.BUM_OFS);
      picks[ind]=0;
    }
  }
  
  // kill Bomber by fire
  void fire(AniBomber myAniBomber) {
    int ind=index(myAniBomber.pos_x,myAniBomber.pos_y);
    if ((marks[ind]&Animated.ANI_FIRE)==Animated.ANI_FIRE)
      myAniBomber.kill();          
  }
  
  // warp: Bomber, Bomb, ... ?
  void warp(AniWarpable myAniWarpable) {
    int ind=index(myAniWarpable.pos_x,myAniWarpable.pos_y);
    if (myString.charAt(ind)=='*'&&myAniWarpable.warp<Animated.utc)
      if (Math.abs(getPos_x(ind)-myAniWarpable.pos_x)+Math.abs(getPos_y(ind)-myAniWarpable.pos_y)<15) {
        if (myAniWarpable instanceof AniBomb)
          if (0==myRandom.nextInt(warprej)) {
            AniBomb myAniBomb=(AniBomb)myAniWarpable;
            myAniBomb.explode=Animated.utc+myAniBomb.DELAY[1];
            if (0<=myAniBomb.uiv2)
              myAniBomb.uiv2=myAniBomb.INVERSE[myAniBomb.uiv2];
            return;
          }
        // warping
        Animated.myListIterator.add(new AniVoidstar(Animated.FLASH,0,4,myAniWarpable.pos_x,myAniWarpable.pos_y,4));
        random=ind;
        while (random==ind)
          random=((Integer)myHashtable[HASH_WARP].get(new Integer(myRandom.nextInt(myHashtable[HASH_WARP].size())))).intValue();
        myAniWarpable.warp=Animated.utc+13;
        myAniWarpable.pos_x=getPos_x(random);
        myAniWarpable.pos_y=getPos_y(random);
      }    
  }
  
  void kick(AniBomb myAniBomb) {
    int c1;
    for (c1=0;c1<kicks_num;c1+=3)
      if (Math.abs(kicks[c1+1]-myAniBomb.pos_x)+Math.abs(kicks[c1+2]-myAniBomb.pos_y)<35) {
        myAniBomb.sense=  Animated.utc+2;
        myAniBomb.explode=Animated.utc+AniBomb.TYPE0;
        myAniBomb.kick(kicks[c1]);
      }
  }
  
  int[] move(int pos_x,int pos_y,int uiv2,int step) {
    int ind,dfx,dfy;
    int seg =MASK_SEGM;
    int seg2=MASK_SEGM/2;
    int[] pos=new int[3];
    pos[0]=pos_x;
    pos[1]=pos_y;    
    switch (uiv2) {
      case 0: // down
        ind=index(pos[0],pos[1]+step+seg2);
        if ((field[ind]&MASK_MOVE)==0) {
          pos[1]=getPos_y(ind-width); // correct y offset
        } else {
          dfx=Math.max(Math.min(getPos_x(ind-width)-pos[0],step),-step);
          pos[0]+=dfx;
          pos[1]+=step-Math.abs(dfx);
          pos[2]=1;
        }
        break;
      case 1: // left        
        ind=index(pos[0]-step-seg2,pos[1]);
        if ((field[ind]&MASK_MOVE)==0) {
          pos[0]=getPos_x(ind+1); // correct x offset          
        } else {                  
          dfy=Math.max(Math.min(getPos_y(ind+1)-pos[1],step),-step);
          pos[1]+=dfy;
          pos[0]-=step-Math.abs(dfy);
          pos[2]=1;
        }
        break;
      case 2: // right
        ind=index(pos[0]+step+seg2,pos[1]);
        if ((field[ind]&MASK_MOVE)==0) {
          pos[0]=getPos_x(ind-1); // correct x offset          
        } else {
          dfy=Math.max(Math.min(getPos_y(ind-1)-pos[1],step),-step);
          pos[1]+=dfy;
          pos[0]+=step-Math.abs(dfy);
          pos[2]=1;
        }
        break;
      case 3: // up
        ind=index(pos[0],pos[1]-step-seg2);
        if ((field[ind]&MASK_MOVE)==0) {
          pos[1]=getPos_y(ind+width); // correct y offset
        } else {
          dfx=Math.max(Math.min(getPos_x(ind+width)-pos[0],step),-step);
          pos[0]+=dfx;
          pos[1]-=step-Math.abs(dfx);
          pos[2]=1;
        }
        break;
    }
    return pos;
  }
  
  int lane(int ind) {
    int myInt=1;        // right
    if ((ind%width)==0) 
      myInt=2;          // left      
    if (ind<width-1)
      myInt=0;          // top
    if ((height-1)*width<ind)
      myInt=3;          // bottom
    return myInt;
  }
  
  boolean corner(int ind) {
    return ind==0||ind==width-1||ind==(height-1)*width||ind==height*width-1;
  }
  
  int saf_x(int pos_x) {
    return Math.min(Math.max(25,pos_x),50*width-25);
  }
  int saf_y(int pos_y) {
    return Math.min(Math.max(25,pos_y),50*height-25);
  }
  
}
